/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/base.glsl"), digest: "b14895de76d4a441"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush.glsl"), digest: "2b3f8d6dade32db0"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_blend.glsl"), digest: "1cccb67e062f7eb7"});
    shaders.insert("brush_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_conic_gradient.glsl"), digest: "2bdce0bb64e4c40c"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_image.glsl"), digest: "1dbe8c5d3fb6256b"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "f2b530ae75339003"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "826bed4f1c949061"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "c5626636901e7cba"});
    shaders.insert("brush_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_radial_gradient.glsl"), digest: "b9773692a7dd8018"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_solid.glsl"), digest: "df232f8d3ba20c1f"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "41624971fdc7ade7"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/clip_shared.glsl"), digest: "285fa2928ebba3d6"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/composite.glsl"), digest: "cefadbbc154ee1ef"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_blur.glsl"), digest: "7c24cacb5b972cc7"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "9c212a82c46f3383"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "3d060549f0e7277c"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "73092de39207e065"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "cf8a37a37ecd9738"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "568a0fa28ab5400e"});
    shaders.insert("cs_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_gradient.glsl"), digest: "138aedc206fda172"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "d22933e6d52615dc"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_scale.glsl"), digest: "ea46a8fac2ec0d2a"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "7e588abe5fd037d8"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/debug_color.glsl"), digest: "c807ebc46aa8b3a7"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/debug_font.glsl"), digest: "8da52bdc4ea28fd6"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/ellipse.glsl"), digest: "e254e21d32e6cf5c"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "a2bac6d1bcff1991"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "810e56579bee2fad"});
    shaders.insert("pf_vector_cover", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/pf_vector_cover.glsl"), digest: "a47be1df7b779e69"});
    shaders.insert("pf_vector_stencil", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/pf_vector_stencil.glsl"), digest: "cabeeb7c32f8cb1d"});
    shaders.insert("pls_init", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/pls_init.glsl"), digest: "652498fd154d7495"});
    shaders.insert("pls_resolve", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/pls_resolve.glsl"), digest: "d0a4548ea4230612"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/prim_shared.glsl"), digest: "d64840cdbf58da50"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/ps_clear.glsl"), digest: "3acfd8a1f197f55b"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "1519136f2a1b2bf"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "4053f50de22dd7dd"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/rect.glsl"), digest: "f76a75fecfd22688"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/render_task.glsl"), digest: "962a4083be1b63d0"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/shared.glsl"), digest: "ce6edf74cc6cac92"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/transform.glsl"), digest: "444c30f931d923a1"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-84.0.1/gfx/wr/webrender/res/yuv.glsl"), digest: "de3c30e1cf0b7d94"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_blend_Gl.frag"),
        digest: "8fdc142a8ecfb507",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "5ac744dad005410a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "36c54fba855afb04",
    });
    shaders.insert((ShaderVersion::Gl, "brush_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_conic_gradient_Gl.frag"),
        digest: "8ccaf09531de5ed4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_conic_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_conic_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_conic_gradient_ALPHA_PASS_Gl.frag"),
        digest: "b89c6455e3c283b9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_conic_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_conic_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_conic_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "77121533e8b25731",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_Gl.frag"),
        digest: "62dd47e6a5a93891",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_Gl.frag"),
        digest: "8a5e470c535dd879",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_Gl.frag"),
        digest: "6468151adaf1eda8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "c7dc33157969c05e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "583239a7619ce021",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "cb21652316f2a49f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "9c3d82308a87a43",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_Gl.frag"),
        digest: "aafeb699804491d1",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_Gl.frag"),
        digest: "1627093d06fdeab7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "fd75fa5abe006048",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "7acc61a2e95cf3b6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_Gl.frag"),
        digest: "ee2814849ccd39c4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "1fd26ab7f3c0eed4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "ca168d3c8b5e7b06",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_Gl.frag"),
        digest: "f498d7e81df8f52b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "25bc0bca9c725a27",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "8aa936bad5f4ced0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "5975f2d5b54132a7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "a61e05332ebe6da0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_Gl.frag"),
        digest: "3d70935334f87f7e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "e0907137ea0ce023",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "607a23b408fe1732",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_REPETITION_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_REPETITION_Gl.frag"),
        digest: "d0358c340fe97d58",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "fcc8d9630f0cca13",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "cf1187d096b77a37",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_DEBUG_OVERDRAW_Gl.frag"),
        digest: "75c99cdc0aba5933",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "7ee5bafd9bb3343b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "897c072ea81f2607",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "745508a00566d60d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "910c4b1eb91ef9b1",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_linear_gradient_Gl.frag"),
        digest: "8d5c019c9feee19d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "ad591ba3dbc9fad5",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "4234e007ba862481",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_mix_blend_Gl.frag"),
        digest: "b7b65795ab54b5c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "a9cec8bc700c886d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "ffd856bea9720d2a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_Gl.frag"),
        digest: "826e8d2c58c34e7d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "83ac2b261f142458",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "c6829dbe76f5c9a1",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "e629412b1fd32f77",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "4b831f511276a353",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "846b566417f08d09",
    });
    shaders.insert((ShaderVersion::Gl, "brush_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_radial_gradient_Gl.frag"),
        digest: "db4c129800ba46a9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_radial_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_radial_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_radial_gradient_ALPHA_PASS_Gl.frag"),
        digest: "76549fb2eb0ec57e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_radial_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_radial_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_radial_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "feb5659e6f29e813",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_solid_Gl.frag"),
        digest: "57f520fe4eaeabed",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "fad2e08796cad16c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "a552bdd4e0c32355",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "d786fd2ac031d2ef",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "756b03b69a3ea873",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_ALPHA_PASS_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_ALPHA_PASS_YUV_Gl.frag"),
        digest: "524be19c9708f6a6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "b447f613165bb94b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "2138bd4fb093227b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_DEBUG_OVERDRAW_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_DEBUG_OVERDRAW_YUV_Gl.frag"),
        digest: "cec9c4355703fbad",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "ab40f7e46892b058",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "8187777affd1f005",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/brush_yuv_image_YUV_Gl.frag"),
        digest: "247455f008b4384f",
    });
    shaders.insert((ShaderVersion::Gl, "composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_Gl.frag"),
        digest: "d5fca6e0a1e2e22d",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "735e8fd876514e64",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "3a34a9060a4300c1",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "9ec7eb5a4538cf9a",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "a03a6c9879d458a4",
    });
    shaders.insert((ShaderVersion::Gl, "composite_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/composite_YUV_Gl.frag"),
        digest: "9ff84f65e83f59cd",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "30f21f99e1771063",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "bbeed9dbd76a3c0c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_border_segment_Gl.frag"),
        digest: "a9b71cb6b6447832",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_border_solid_Gl.frag"),
        digest: "e6b74a40738f5658",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_box_shadow_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_box_shadow_Gl.frag"),
        digest: "5c4afd0767f7509",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_image_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_image_Gl.frag"),
        digest: "e5797b4c46b2ebe3",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_rectangle_Gl.frag"),
        digest: "682268d8ef060bff",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "d692dda166494400",
    });
    shaders.insert((ShaderVersion::Gl, "cs_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_gradient_Gl.frag"),
        digest: "7713c41d03e3256c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_line_decoration_Gl.frag"),
        digest: "a1038d3309f494d9",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_scale_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_scale_Gl.frag"),
        digest: "522b4b3a870e138",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "bc6649e6d0e23740",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "694d15d3f383c55",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/cs_svg_filter_Gl.frag"),
        digest: "53283d99bf16a40f",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/debug_font_Gl.frag"),
        digest: "76997b39dc30601e",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_clear_Gl.frag"),
        digest: "e696a5e94c11171b",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_split_composite_Gl.frag"),
        digest: "73ff9f9cb1166ff9",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_Gl.frag"),
        digest: "f9e211188ee3fd75",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_Gl.frag"),
        digest: "8dbdd46238095e48",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_Gl.frag"),
        digest: "f15c60a05add1980",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_Gl.frag"),
        digest: "c7ea686f3a962ee8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_DEBUG_OVERDRAW_Gl.frag"),
        digest: "598ccce121f5b645",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-84.0.1/objdir/aarch64-unknown-linux-gnu/release/build/webrender-2ce5d7eb9d36d5e3/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_Gl.frag"),
        digest: "c5af93819ac60c6a",
    });
    shaders
  };
}
