//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LookAndFeelTypes_h
#define LookAndFeelTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/widget/WidgetMessageUtils.h"
#include "nsColor.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelInt|
//
namespace mozilla {
namespace widget {
class LookAndFeelInt final
{
private:
    typedef mozilla::LookAndFeel::IntID IntID;

public:
    MOZ_IMPLICIT LookAndFeelInt() :
        id_(),
        value_()
    {
    }

    MOZ_IMPLICIT LookAndFeelInt(
            const IntID& _id,
            const int32_t& _value) :
        id_(_id),
        value_(_value)
    {
    }

    IntID&
    id()
    {
        return id_;
    }
    const IntID&
    id() const
    {
        return id_;
    }

    int32_t&
    value()
    {
        return value_;
    }
    const int32_t&
    value() const
    {
        return value_;
    }

private:
    IntID id_;
    int32_t value_;
};
} // namespace widget
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::widget::LookAndFeelInt>
{
    typedef mozilla::widget::LookAndFeelInt paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelFont|
//
namespace mozilla {
namespace widget {
class LookAndFeelFont final
{
private:

public:
    MOZ_IMPLICIT LookAndFeelFont() :
        haveFont_(),
        name_(),
        italic_(),
        size_(),
        weight_()
    {
    }

    MOZ_IMPLICIT LookAndFeelFont(
            const bool& _haveFont,
            const nsString& _name,
            const float& _size,
            const float& _weight,
            const bool& _italic) :
        haveFont_(_haveFont),
        name_(_name),
        italic_(_italic),
        size_(_size),
        weight_(_weight)
    {
    }

    bool&
    haveFont()
    {
        return haveFont_;
    }
    const bool&
    haveFont() const
    {
        return haveFont_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    float&
    size()
    {
        return size_;
    }
    const float&
    size() const
    {
        return size_;
    }

    float&
    weight()
    {
        return weight_;
    }
    const float&
    weight() const
    {
        return weight_;
    }

    bool&
    italic()
    {
        return italic_;
    }
    const bool&
    italic() const
    {
        return italic_;
    }

private:
    void
    StaticAssertions() const;
    bool haveFont_;
    nsString name_;
    bool italic_;
    float size_;
    float weight_;
};
} // namespace widget
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::widget::LookAndFeelFont>
{
    typedef mozilla::widget::LookAndFeelFont paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelColor|
//
namespace mozilla {
namespace widget {
class LookAndFeelColor final
{
private:
    typedef mozilla::LookAndFeel::ColorID ColorID;

public:
    MOZ_IMPLICIT LookAndFeelColor() :
        id_(),
        color_()
    {
    }

    MOZ_IMPLICIT LookAndFeelColor(
            const ColorID& _id,
            const nscolor& _color) :
        id_(_id),
        color_(_color)
    {
    }

    ColorID&
    id()
    {
        return id_;
    }
    const ColorID&
    id() const
    {
        return id_;
    }

    nscolor&
    color()
    {
        return color_;
    }
    const nscolor&
    color() const
    {
        return color_;
    }

private:
    ColorID id_;
    nscolor color_;
};
} // namespace widget
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::widget::LookAndFeelColor>
{
    typedef mozilla::widget::LookAndFeelColor paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelCache|
//
namespace mozilla {
namespace widget {
class LookAndFeelCache final
{
private:
    typedef mozilla::widget::LookAndFeelInt LookAndFeelInt;
    typedef mozilla::widget::LookAndFeelFont LookAndFeelFont;
    typedef mozilla::widget::LookAndFeelColor LookAndFeelColor;

public:
    MOZ_IMPLICIT LookAndFeelCache() :
        mInts_(),
        mFonts_(),
        mColors_()
    {
    }

    MOZ_IMPLICIT LookAndFeelCache(
            const nsTArray<LookAndFeelInt>& _mInts,
            const nsTArray<LookAndFeelFont>& _mFonts,
            const nsTArray<LookAndFeelColor>& _mColors) :
        mInts_(_mInts),
        mFonts_(_mFonts),
        mColors_(_mColors)
    {
    }

    nsTArray<LookAndFeelInt>&
    mInts()
    {
        return mInts_;
    }
    const nsTArray<LookAndFeelInt>&
    mInts() const
    {
        return mInts_;
    }

    nsTArray<LookAndFeelFont>&
    mFonts()
    {
        return mFonts_;
    }
    const nsTArray<LookAndFeelFont>&
    mFonts() const
    {
        return mFonts_;
    }

    nsTArray<LookAndFeelColor>&
    mColors()
    {
        return mColors_;
    }
    const nsTArray<LookAndFeelColor>&
    mColors() const
    {
        return mColors_;
    }

private:
    CopyableTArray<LookAndFeelInt> mInts_;
    CopyableTArray<LookAndFeelFont> mFonts_;
    CopyableTArray<LookAndFeelColor> mColors_;
};
} // namespace widget
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::widget::LookAndFeelCache>
{
    typedef mozilla::widget::LookAndFeelCache paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef LookAndFeelTypes_h
