// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */


pub mod fog {
    use crate::private::*;
    use glean_core::CommonMetricData;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog.initialization
    ///
    /// Time the FOG initialization takes.
    pub static initialization: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(1.into(), CommonMetricData {
            name: "initialization".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod fog_ipc {
    use crate::private::*;
    use glean_core::CommonMetricData;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.replay_failures
    ///
    /// The number of times the ipc buffer failed to be replayed in the
    /// parent process.
    pub static replay_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(2.into(), CommonMetricData {
            name: "replay_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod fog_validation {
    use crate::private::*;
    use glean_core::CommonMetricData;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog_validation.legacy_telemetry_client_id
    ///
    /// The Telemetry client_id. To be sent only in the "fog-validation" ping.
    pub static legacy_telemetry_client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(3.into(), CommonMetricData {
            name: "legacy_telemetry_client_id".into(),
            category: "fog_validation".into(),
            send_in_pings: vec!["fog-validation".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only {
    use crate::private::*;
    use glean_core::CommonMetricData;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.bad_code
    ///
    /// Number of times we encountered bad code.
    /// This is a test-only metric.
    pub static bad_code: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(4.into(), CommonMetricData {
            name: "bad_code".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_time_it
    ///
    /// Test metric for a timespan.
    /// This is a test-only metric.
    pub static can_we_time_it: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(5.into(), CommonMetricData {
            name: "can_we_time_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string
    ///
    /// Only the cheesiest of strings.
    /// This is a test-only metric.
    pub static cheesy_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(6.into(), CommonMetricData {
            name: "cheesy_string".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_id_it
    ///
    /// Just a UUID.
    /// This is a test-only metric.
    pub static what_id_it: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(7.into(), CommonMetricData {
            name: "what_id_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only_ipc {
    use crate::private::*;
    use glean_core::CommonMetricData;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(8.into(), CommonMetricData {
            name: "a_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things.
    pub static a_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(9.into(), CommonMetricData {
            name: "a_bool".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_date
    ///
    /// This is a test-only metric.
    /// Just putting things on the calendar.
    pub static a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(10.into(), CommonMetricData {
            name: "a_date".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string
    ///
    /// This is a test-only metric.
    /// Just setting some strings.
    pub static a_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(11.into(), CommonMetricData {
            name: "a_string".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_memory_dist
    ///
    /// This is a test-only metric.
    /// Just measuring memory.
    pub static a_memory_dist: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(12.into(), CommonMetricData {
            name: "a_memory_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_timing_dist
    ///
    /// This is a test-only metric.
    /// Just measuring time.
    pub static a_timing_dist: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(13.into(), CommonMetricData {
            name: "a_timing_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string_list
    ///
    /// This is a test-only metric.
    /// Just appending some strings.
    pub static a_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(14.into(), CommonMetricData {
            name: "a_string_list".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Clone, Copy, Hash, Eq, PartialEq)]
    pub enum AnEventKeys {
        Extra1,
    }

    impl ExtraKeys for AnEventKeys {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1"];

        fn index(self) -> i32 {
            self as i32
        }
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static an_event: Lazy<EventMetric<AnEventKeys>> = Lazy::new(|| {
        EventMetric::new(15.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_uuid
    ///
    /// This is a test-only metric.
    /// Just recording some unique identifiers.
    pub static a_uuid: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(16.into(), CommonMetricData {
            name: "a_uuid".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}

#[allow(dead_code)]
pub(crate) mod __glean_metric_maps {
    use std::collections::HashMap;

    use crate::private::*;
    use once_cell::sync::Lazy;

    pub static TIMESPAN_MAP: Lazy<HashMap<MetricId, &Lazy<TimespanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2);
        map.insert(1.into(), &super::fog::initialization);
        map.insert(5.into(), &super::test_only::can_we_time_it);
        map
    });

    pub static COUNTER_MAP: Lazy<HashMap<MetricId, &Lazy<CounterMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(2.into(), &super::fog_ipc::replay_failures);
        map.insert(4.into(), &super::test_only::bad_code);
        map.insert(8.into(), &super::test_only_ipc::a_counter);
        map
    });

    pub static UUID_MAP: Lazy<HashMap<MetricId, &Lazy<UuidMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(3.into(), &super::fog_validation::legacy_telemetry_client_id);
        map.insert(7.into(), &super::test_only::what_id_it);
        map.insert(16.into(), &super::test_only_ipc::a_uuid);
        map
    });

    pub static STRING_MAP: Lazy<HashMap<MetricId, &Lazy<StringMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2);
        map.insert(6.into(), &super::test_only::cheesy_string);
        map.insert(11.into(), &super::test_only_ipc::a_string);
        map
    });

    pub static BOOLEAN_MAP: Lazy<HashMap<MetricId, &Lazy<BooleanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(9.into(), &super::test_only_ipc::a_bool);
        map
    });

    pub static DATETIME_MAP: Lazy<HashMap<MetricId, &Lazy<DatetimeMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(10.into(), &super::test_only_ipc::a_date);
        map
    });

    pub static MEMORY_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<MemoryDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(12.into(), &super::test_only_ipc::a_memory_dist);
        map
    });

    pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<TimingDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(13.into(), &super::test_only_ipc::a_timing_dist);
        map
    });

    pub static STRING_LIST_MAP: Lazy<HashMap<MetricId, &Lazy<StringListMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(14.into(), &super::test_only_ipc::a_string_list);
        map
    });

}

